
function G = cost_rls(lambda,A,b,Q,W,H,E_a,E_b)

 % This function returns  the value of the 
 % function G(lambda), whose minimum over
 % lambda determines lambda_hat.
 
 % Written by A. H. Sayed, Dec. 1, 1999


 [N,m] = size(H);      % dimensions

 % Evaluation of W(lambda)
 X1 = lambda*eye(m,m) - H'*W*H;   
 W_lambda = W + W*H*pinv(X1)*H'*W; 

 % Evaluation of x(lambda)
 X2 = Q + lambda*E_a'*E_a + A'*W_lambda*A;
 x_lambda = inv(X2)*(A'*W_lambda*b + lambda*E_a'*E_b);

 % Evaluation of G(lambda)
 X3 = x_lambda'*Q*x_lambda;
 X4 = (A*x_lambda - b)'*W_lambda*(A*x_lambda - b);
 X5 = lambda*(E_a*x_lambda - E_b)'*(E_a*x_lambda - E_b);
 G = X3 + X4 + X5;

